<?php
/**
 * MP Tags Addon
 * @author bade[at]maple-park[dot]de Heinz Bade
 * @author <a href="http://www.maple-park.de">www.maple-park.de</a>
 * @package redaxo 4.3
 * @version $Id: config.inc.php,v 1.2 2011/07/23 16:46:00 elektra$
 */

$mypage = 'mp_tags';

if ($REX['REDAXO'])
{
  // include file with translations
  $I18N->appendFile($REX['INCLUDE_PATH'].'/addons/'.$mypage.'/lang/');

  // define addon vars
  $REX['ADDON']['page'][$mypage] = $mypage;
  $REX['ADDON']['name'][$mypage] = $I18N->msg('tags_title');
  $REX['ADDON']['perm'][$mypage] = 'mp_tags[]';
  $REX['ADDON']['version'][$mypage] = '1.2';
  $REX['ADDON']['author'][$mypage] = 'Heinz Bade, maple park Ltd.';

  // define permissions
  $REX['PERM'][] = 'mp_tags[]';
  $REX['EXTPERM'][] = 'mp_tags[setup]';

  // handle backend pages/subpages
  $REX['ADDON']['pages'][$mypage] = array();
  $REX['ADDON']['pages'][$mypage][] = array('tags', $I18N->msg('tags_tags'));
  $REX['ADDON']['pages'][$mypage][] = array('manual', $I18N->msg('tags_manual'));
  if (isset($REX['USER']) && is_object($REX['USER']) && ($REX['USER']->hasPerm('mp_tags[setup]') || $REX['USER']->isAdmin()))
  {
    $REX['ADDON']['pages'][$mypage][] = array('settings', $I18N->msg('tags_settings'));
  }

  // add extensions for backend pages
  require_once $REX['INCLUDE_PATH'].'/addons/'.$mypage.'/functions/function_extensions_backend.inc.php';
  rex_register_extension('PAGE_CHECKED', 'mp_tags_handle_extensions');
}
else
{
  // include file with frontend extensions
  require_once $REX['INCLUDE_PATH'].'/addons/'.$mypage.'/functions/function_extensions_frontend.inc.php';
  // add css/js files to page header
  rex_register_extension('OUTPUT_FILTER', 'mp_tags_add_header_files');
}

// --- DYN
$REX['ADDON'][$mypage]['add_tag_on_the_fly'] = 0;
$REX['ADDON'][$mypage]['article_id_for_list'] = 0;
// --- /DYN

?>