<?php

/**
 * Aktualisiert das Tag-Field 'rel_art_count', wenn ein Tag gespeichert wird
 * Es werden nur Artikel mit Status = "online" gezhlt
 *
 * @param $params Parameter des EP 'REX_FORM_SAVED' (form, sql)
 */
function mp_tags_update_article_count($params)
{
  $debug = false;

  $form = $params['form'];
  $clang = $form->getParam('clang');
  $sql = $params['sql'];

  $sel = rex_sql::factory();
  $sel->setDebug($debug);
  $sel->setTable($form->getTableName());
  if ($form->isEditMode()) {
    $where = $form->getWhereCondition();
  } else {
    $where = 'id = '. $sql->getLastId();
  }
  $sel->setWhere($where);
  $sel->select('rel_art_ids');
  if ($sel->getRows() == 1)
  {
    $rel_art_ids = explode('|', trim($sel->getValue('rel_art_ids'), '|'));
    $rel_art_count = 0;
    if (count($rel_art_ids) > 0)
    {
			foreach ($rel_art_ids as $rel_art_id)
			{
				if (!is_numeric($rel_art_id)) continue;
				$art = OOArticle::getArticleById($rel_art_id, $clang);
				if (OOArticle::isValid($art) && $art->isOnline())
				{
					$rel_art_count += 1;
				}
			}
    }
    $upd = rex_sql::factory();
    $upd->setDebug($debug);
    $upd->setTable($form->getTableName());
    $upd->setValue('rel_art_count', $rel_art_count);
    $upd->addGlobalUpdateFields();
    $upd->setWhere($where);
    return $upd->update();
  }

  return null;
}

?>