<?php

/**
 * Registriert die bentigen Extensions im Backend
 * 
 * @param $params Parameter des EP 'PAGE_CHECKED'
 */
function mp_tags_handle_extensions($params)
{
  global $REX;

  $page = $params['subject'];

  // include extensions
  if ($page == 'content')
  {
    require_once $REX['INCLUDE_PATH'].'/addons/mp_tags/extensions/extension_content.inc.php';
    if (rex_request('mode', 'string') == 'tags')
    {
      // add css files to page header
      rex_register_extension('PAGE_HEADER', 'mp_tags_add_header_files');
    }
    // add tag link to content menu
    rex_register_extension('PAGE_CONTENT_MENU', 'mp_tags_add_content_menu_link');
  }
  elseif ($page == 'structure')
  {
    require_once $REX['INCLUDE_PATH'].'/addons/mp_tags/extensions/extension_structure.inc.php';
    // get article status for every language before article is deleted
    rex_register_extension('ART_PRE_DELETED', 'mp_tags_structure_item_pre_deleted');
    // delete tag article relation if article has been deleted
    rex_register_extension('ART_DELETED', 'mp_tags_structure_item_deleted');
    // delete tag article relation if article status has been changed to offline
    rex_register_extension('ART_STATUS', 'mp_tags_structure_status_changed');
    // delete tag article relation if category has been deleted
    rex_register_extension('CAT_DELETED', 'mp_tags_structure_item_deleted');
    // delete tag article relation if category status has been changed to offline
    rex_register_extension('CAT_STATUS', 'mp_tags_structure_status_changed');
  }
  elseif ($page == 'specials')
  {
    require_once $REX['INCLUDE_PATH'].'/addons/mp_tags/extensions/extension_language.inc.php';
    // delete tags/categories related to a language if this language has been deleted
    rex_register_extension('CLANG_DELETED', 'mp_tags_clang_deleted');
  }
}

?>