<?php
/**
 * MP Tags Addon
 * Module "tag articles" OUTPUT
 */

if (OOAddon::isAvailable('mp_tags'))
{
  // get id of the tag by request
  $tag_id = rex_request('tag_id', 'int', 0);

  // the headline with "tag"-placeholder
  $headline = "REX_VALUE[1]";

  // message if no articles found
  $no_articles = "REX_VALUE[2]";

  // init some vars
  $term = '???';
  $rel_art_ids = array();
  $rel_art_count = 0;

  // get values from database
  $sql = rex_sql::factory();
  $sql->setDebug(false);
  $sql->setQuery("SELECT `term`, `rel_art_ids`, `rel_art_count`
                  FROM `". $REX['TABLE_PREFIX'] ."mp_tags`
                  WHERE `clang` = ". $REX['CUR_CLANG'] ."
                    AND `id` = ". $tag_id);
  if ($sql->getRows() == 1)
  {
    $term = $sql->getValue('term');
    $rel_art_ids = explode('|', trim($sql->getValue('rel_art_ids'), '|'));
  }

  if (strpos($headline, '{0}') !== false)
  {
    echo "\n".'<h2>'. str_replace('{0}', $term, $headline) .'</h2>';
  }
  else
  {
    echo "\n".'<h2>'. $headline .'</h2>';
  }

  if (count($rel_art_ids) > 0)
  {
    echo "\n".'<div class="article-list">';
    foreach ($rel_art_ids as $rel_art_id)
    {
      $article = OOArticle::getArticleById($rel_art_id, $REX['CUR_CLANG']);
      $articleName = $article->getValue('name');
      $articleDescription = nl2br($article->getValue('art_description'));
      $articleUrl = $article->getUrl();
      echo "\n".'<p><strong><a href="'.$articleUrl.'" title="'.$articleName.'">'.$articleName.'</a></strong><br>'.$articleDescription.'</p>';
    }
    echo "\n".'</div>';
  }
  else
  {
    echo "\n".'<p>'. $no_articles .'</p>';
  }

}
else
{
  // addon is not available
  echo rex_warning('Dieses Modul bentigt das "mp_tags" Addon!');

}

?>