<?php
/**
 * MP Tags Addon 
 * @author bade[at]maple-park[dot]de Heinz Bade
 * @author <a href="http://www.maple-park.de">www.maple-park.de</a>
 * @package redaxo 4.3
 * @version $Id: article.inc.php,v 1.0 2010/11/04 16:35:00 elektra$
 */

//------------------------------> Parameter
global $REX, $I18N;
$debug = false;
$article_id = rex_request('article_id', 'rex-article-id', 0);
$clang = rex_request('clang', 'rex-clang-id', 0);
$mode = rex_request('mode', 'string', 'tags');
$submit = rex_request('submit', 'int', 0);
$term = rex_request('term', 'string');
$rel_tags = rex_request('rel_tags', 'array');
$old_tag_ids = rex_request('old_tag_ids', 'string');

//------------------------------> SQL
$sql = rex_sql::factory();
$sql->setDebug($debug);

//------------------------------> Formular abgeschickt ?
if ($submit == 1)
{
  // fge neuen Tag + Artikel-Relation in DB hinzu
  if (!empty($term))
  {
    // prfe ob Tag bereits vorhanden
    $sql->setQuery("SELECT `id`, `rel_art_ids`
                    FROM `". $REX['TABLE_PREFIX'] ."mp_tags`
                    WHERE `clang` = ". $clang ."
                      AND `term` LIKE '". $term ."'");
    if ($sql->getRows() > 0)
    {
      // Tag schon vorhanden
      echo rex_warning($I18N->msg('tags_form_tag_already_exists', $new_tag));
      $tag_id = $sql->getValue('id');
      $rel_art_ids = $sql->getValue('rel_art_ids');
      if (stripos($rel_art_ids, '|'.$article_id.'|') === false)
      {
        // Tag vorhanden, aber nicht mit Artikel verknpft
        $articles = str_replace('|'.$article_id.'|', '|', $rel_art_ids);
        $sql->setQuery("UPDATE `". $REX['TABLE_PREFIX'] ."mp_tags`
                        SET `rel_art_ids` = '". rtrim($rel_art_ids, '|').'|'.$article_id.'|' ."'
                        WHERE `id` = ". $tag_id ." LIMIT 1");
        echo rex_info($I18N->msg('tags_form_tag_article_relation_added', $term));
      }
    }
    else
    {
      // Tag noch nicht vorhanden
      $sql->setQuery("INSERT INTO `". $REX['TABLE_PREFIX'] ."mp_tags`
                      SET `clang` = ".$clang.",
                          `term` = '".$term."',
                          `rel_art_ids` = '|".$article_id."|',
                          `rel_art_count` = 1,
                          `createuser` = '". $REX['USER']->getValue('login') ."',
                          `createdate` = ". time());
      echo rex_info($I18N->msg('tags_form_tag_added', $term));
    }
  }
  // aktualisiere die Tag-Artikel-Relationen in der DB
  $old_tag_ids = explode(',', $old_tag_ids);
  if ($rel_tags != $old_tag_ids)
  {
    // lsche Tag-Artikel-Relationen, wenn ntig
    $diff = array_diff($old_tag_ids, $rel_tags);
    if (count($diff) > 0)
    {
      $sql->setQuery("UPDATE `". $REX['TABLE_PREFIX'] ."mp_tags`
                      SET `rel_art_ids` = REPLACE(`rel_art_ids`, '|". $article_id ."|', '|'),
                          `rel_art_count` = `rel_art_count` - 1,
                          `updateuser` = '". $REX['USER']->getValue('login') ."',
                          `updatedate` = ". time() ."
                      WHERE `clang` = ". $clang ."
                        AND `id` IN (". implode(',', $diff) .")");
    }
    // fge Tag-Artikel-Relationen hinzu, wenn ntig
    $diff = array_diff($rel_tags, $old_tag_ids);
    if (count($diff) > 0)
    {
      $sql->setQuery("UPDATE `". $REX['TABLE_PREFIX'] ."mp_tags`
                      SET `rel_art_ids` = CONCAT(TRIM(TRAILING '|' FROM `rel_art_ids`), '|".$article_id."|'),
                          `rel_art_count` = `rel_art_count` + 1,
                          `updateuser` = '". $REX['USER']->getValue('login') ."',
                          `updatedate` = ". time() ."
                      WHERE `clang` = ". $clang ."
                        AND `id` IN (". implode(',', $diff) .")");
    }
  }
}

?>
  <!-- *** OUTPUT OF ARTICLE-CONTENT-TAGS-MODE - START *** -->
  <div class="rex-form"  id="rex-form-content-tagsmode">
    <form action="index.php" method="post" id="REX_FORM">
      <input type="hidden" name="page" value="content" />
      <input type="hidden" name="article_id" value="<?php echo $article_id; ?>" />
      <input type="hidden" name="mode" value="tags" />
      <input type="hidden" name="submit" value="1" />
      <input type="hidden" name="clang" value="<?php echo $clang; ?>" />
      <input type="hidden" name="ctype" value="<?php echo $ctype; ?>" />
<?php      
if ($REX['ADDON']['mp_tags']['add_tag_on_the_fly'] == 1)
{
?>
      <div class="rex-form-section">
        <fieldset class="rex-form-col-1">
          <legend><span><?php echo $I18N->msg('tags_form_add_tag'); ?></span></legend>
          <div class="rex-form-wrapper">
            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-text">
                <label for="rex-form-term"><?php echo $I18N->msg('tags_form_label_new_term'); ?></label>
                <input class="rex-form-text" type="text" id="rex-form-term" name="term" value="" size="30" <?php echo rex_tabindex(); ?> />
                <span class="rex-form-notice"><?php echo $I18N->msg('tags_notice_term'); ?></span>
              </p>
            </div>
            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-submit">
                <input class="rex-form-submit" type="submit" value="<?php echo $I18N->msg('form_save'); ?>" title="<?php echo $I18N->msg('form_save'); ?>" />
              </p>
            </div>
          </div>
          <div class="rex-clearer"></div>
        </fieldset>
      </div>
<?php      
}  // if add_tag_on_the_fly
?>
      <div class="rex-form-section">
        <fieldset class="rex-form-col-1">
          <legend><span><?php echo $I18N->msg('tags_form_select_tags'); ?></span></legend>
          <div class="rex-form-wrapper">
            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-checkboxes">
                <label for="rex-form-select-tags"><?php echo $I18N->msg('tags_form_label_tags'); ?></label>
                <span class="rex-form-checkboxes-wrapper"><?php

$sel = rex_sql::factory();
$sel->setDebug($debug);
$sel->setQuery("SELECT `id`, `term`, `rel_art_ids`
                FROM `". $REX['TABLE_PREFIX']. "mp_tags`
                WHERE `clang` = ". $clang ."
                ORDER BY `term` ASC");
if ($sel->getRows() > 0)
{
  $related_tags = array();
  for ($i = 0; $i < $sel->getRows(); $i++)
  {
    $tag_id = $sel->getValue('id');
    echo '<label class="rex-form-checkbox"><input type="checkbox" class="rex-form-checkbox" id="rex-form-rel-tag-'. $tag_id .'" name="rel_tags[]" value="'. $tag_id .'"';
    if (strpos($sel->getValue('rel_art_ids'), '|'.$REX['ARTICLE_ID'].'|') !== false) {
      echo ' checked="checked"';
      $related_tags[] = $tag_id;
    }
    echo ' />'. $sel->getValue('term') .'</label> ';
    $sel->next();
  }
  echo '<input type="hidden" name="old_tag_ids" value="'.implode(',', $related_tags).'" />';
}
else
{
  echo $I18N->msg('tags_form_no_tags_available');
}
                ?></span>
              </p>
            </div>
            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-submit">
                <input class="rex-form-submit" type="submit" value="<?php echo $I18N->msg('form_save'); ?>" title="<?php echo $I18N->msg('form_save'); ?>" />
              </p>
            </div>
            <div class="rex-clearer"></div>
          </div>
        </fieldset>
      </div>
    </form>
  </div>
  <!-- *** OUTPUT OF ARTICLE-CONTENT-TAGS-MODE - END *** -->
