<?php
/**
 * MP Tags Addon
 * Template "tag cloud"
 */

if (OOAddon::isAvailable('mp_tags'))
{
  // the title for the tag cloud block
  switch ($REX['CUR_CLANG'])
  {
    case 2:  // franzsisch
      $title = 'TagCloud inclus comme un modle';
      break;
    case 1:  // englisch
      $title = 'TagCloud included as template';
      break;
    case 0:  // deutsch
    default:
      $title = 'TagCloud als Template eingebunden';
}

  // max number of tags to show
  $limit = 30;

  // number of different css-classes
  $steps = 6;

  // order of the tags -> alpha or frequency
  $order_by = '`term` ASC';
  //$order_by = '`rel_art_count` DESC';

  // init sql connection
  $sql = rex_sql::factory();
  $sql->setDebug(false);

  // build select query min/max values
  $select = "SELECT MIN(`rel_art_count`) AS freq_min,
                    MAX(`rel_art_count`) AS freq_max,
                    COUNT(`id`) AS tag_count
             FROM `". $REX['TABLE_PREFIX'] ."mp_tags`
             WHERE `clang` = ". $REX['CUR_CLANG'] ."
               AND `rel_art_count` > 0";

  // get query result
  $sql->setQuery($select);
  $freq_min = $freq_max = 1;
  $tag_count = 0;
  if ($sql->getRows() > 0)
  {
    $freq_min = max($freq_min, $sql->getValue('freq_min'));
    $freq_max = max($freq_max, $sql->getValue('freq_max'));
    $tag_count = $sql->getValue('tag_count');
  }
  $freq_range = $freq_max > $freq_min ? log10($freq_max / $freq_min) : 1;

  // build select query for tags
  $select = "SELECT `id`, `term`, `rel_art_count`
             FROM `". $REX['TABLE_PREFIX'] ."mp_tags`
             WHERE `clang` = ". $REX['CUR_CLANG'] ."
               AND `rel_art_count` > 0
             ORDER BY ". $order_by ."
             LIMIT 0,". $limit;

  // get query result
  $sql->setQuery($select);
  if ($sql->getRows() > 0)
  {
    $out = '<div class="tags-cloud-wrapper">'."\n";
    $out .= '<h3 class="tags-cloud-title">'. $title .'</h3>'."\n";
    $out .= '<p class="tags-cloud-links">';
    for ($i = 0; $i < $sql->getRows(); $i++)
    {
      $id = $sql->getValue('id');
      $term = $sql->getValue('term');
      $freq = $sql->getValue('rel_art_count');
      $url = rex_getUrl($REX['ADDON']['mp_tags']['article_id_for_list'], $REX['CUR_CLANG'], array('tag_id' => $id));
      // calculate the weight of the tag in order to get the css class
      $weight = floor($steps * (log10($freq) - log10($freq_min)) / $freq_range);
      //fontSize = MIN_FONT_SIZE + round((MAX_FONT_SIZE - MIN_FONT_SIZE) * weight);  
      $out .= ' <a class="level-'.$weight.'" href="'. $url .'" title="'. $term .' ('. $freq .')">'. $term .'</a> ';
      $sql->next();
    }
    $out .= '</p>'."\n";
    $out .= '</div>'."\n";
    echo $out;
  }
  else
  {
    // no tags found
    echo rex_warning('Keine Tags gefunden!');
  }

}
else
{
  // addon is not available
  echo rex_warning('Das Addon "mp_tags" muss installiert und aktiviert sein!');

}

?>